package dev.shadowsoffire.apotheosis.village.fletching.arrows;

import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraft.ChatFormatting;
import java.util.Locale;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.network.chat.Component;
import java.util.List;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.item.Item;
import java.util.function.Supplier;
import net.minecraft.world.item.ArrowItem;

public class MiningArrowItem extends ArrowItem implements IApothArrowItem
{
    protected final Supplier<Item> breakerItem;
    protected final MiningArrowEntity.Type arrowType;
    
    public MiningArrowItem(final Supplier<Item> breakerItem, final MiningArrowEntity.Type arrowType) {
        super(new Item.Properties());
        this.breakerItem = breakerItem;
        this.arrowType = arrowType;
    }
    
    public AbstractArrow m_6394_(final Level world, final ItemStack stack, final LivingEntity shooter) {
        return new MiningArrowEntity(shooter, world, new ItemStack((ItemLike)this.breakerItem.get()), this.arrowType);
    }
    
    @OnlyIn(Dist.CLIENT)
    public void m_7373_(final ItemStack stack, final Level worldIn, final List<Component> tooltip, final TooltipFlag flagIn) {
        tooltip.add((Component)Component.m_237115_("info.apotheosis.mining_arrow." + this.arrowType.name().toLowerCase(Locale.ROOT)).m_130940_(ChatFormatting.GOLD));
    }
    
    public AbstractArrow fromDispenser(final Level world, final double x, final double y, final double z) {
        return new MiningArrowEntity(world, x, y, z, new ItemStack((ItemLike)this.breakerItem.get()), this.arrowType);
    }
}
